package com.framework.app.api

import com.framework.mvvm.model.data.Model
import com.framework.mvvm.model.vo.Define
import com.framework.mvvm.model.vo.Floor
import com.framework.mvvm.model.vo.Frame
import com.framework.mvvm.model.vo.FrameRequest
import retrofit2.http.Body
import retrofit2.http.POST

interface Api {
    /**
     * 获取自字典数据
     */
    @POST("adm/dict")
    suspend fun getDefine(): Model<Define>

    /**
     * 获取框架数据
     */
    @POST("adm/frame")
    suspend fun getFrame(): Model<Frame>

    @POST("adm/frame")
    suspend fun getFrame(@Body request: FrameRequest): Model<Frame>

    /**
     * 获取楼层数据
     */
    @POST("adm/download")
    suspend fun getFloor(): Model<Floor>

}

