package com.framework.mvvm.model.db.dao

import androidx.room.*
import com.framework.mvvm.model.db.entity.FileEntity

/**
 * 表 file Dao
 */
@Dao
interface FileDao {
    @Query("select * from file")
    suspend fun getFiles(): List<FileEntity>

    @Query("select * from file where id = :id")
    suspend fun getFileById(id: String): FileEntity

    @Insert(onConflict = OnConflictStrategy.REPLACE)
    suspend fun insFile(file: FileEntity)

    @Delete
    suspend fun delFile(file: FileEntity)
}