package com.sybotan.android.demo.adapter;

import android.content.Context;
import android.graphics.Color;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;

import androidx.recyclerview.widget.GridLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.bigkoo.pickerview.builder.TimePickerBuilder;
import com.bigkoo.pickerview.view.TimePickerView;
import com.sybotan.android.demo.R;
import com.sybotan.android.demo.bean.result.Photos;
import com.sybotan.android.demo.view.ListItemView;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

/**
 * Created by lihao.
 * Date: 2021/9/26
 */
public class StaticInfoAdapter extends BaseRecyclerViewAdapter<Object> {
    public static final int TEXT = 1;
    public static final int INT = 2;
    public static final int DOUBLE = 3;
    public static final int ENUM = 4;
    public static final int DATE = 5;
    public static final int MTEXT = 6;
    public static final int PICTURE = 7;

    private TimePickerView pvTime;
    private AddPic addPic;

    public StaticInfoAdapter(Context context, List<Object> beans) {
        super(context, beans);
    }

    @Override
    protected int getItemLayoutId(int viewType) {
        switch (viewType) {
            case TEXT:
                return R.layout.view_text;
            case INT:
                return R.layout.view_int;
            case DOUBLE:
                return R.layout.view_double;
            case ENUM:
                return R.layout.view_enum;
            case DATE:
                return R.layout.view_date;
            case MTEXT:
                return R.layout.view_mtext;
            case PICTURE:
                return R.layout.view_picture;


        }
        return 0;
    }

    @Override
    protected void onBindDataToView(ViewHolder holder, Object o) {
        List<Photos> beans = new ArrayList<>();
        Photos photo = new Photos();
        photo.itemType = 1;
        beans.add(photo);
        PictureAdapter pictureAdapter = new PictureAdapter(mContext, beans, "", false, holder.getCurrentPosition(), 85);
        pictureAdapter.setOnPicAdd(new PictureAdapter.PicAdd() {
            @Override
            public void onPicAdd() {
                if (addPic != null) {
                    addPic.onAddPic();
                }
            }
        });
        RecyclerView recycler = holder.getView(R.id.recycler);
        recycler.setLayoutManager(new GridLayoutManager(mContext, 3));
        recycler.setAdapter(pictureAdapter);
//        switch (o.hashCode()) {
//            case TEXT:
//                break;
//            case INT:
//                break;
//            case DOUBLE:
//                break;
//            case ENUM:
//                break;
//            case DATE:
//                ListItemView listItemView = holder.getView(R.id.view_date);
//                listItemView.getView(R.id.tv_right).setOnClickListener(v -> {
//                    pvTime.show(true);
//                });
//                break;
//            case MTEXT:
//                break;
//            case PICTURE:
//                List<Photos> beans = new ArrayList<>();
//                Photos photo = new Photos();
//                photo.itemType = 1;
//                beans.add(photo);
//                PictureAdapter pictureAdapter = new PictureAdapter(mContext, beans, "", false, holder.getCurrentPosition(), 85);
//                pictureAdapter.setOnPicAdd(new PictureAdapter.PicAdd() {
//                    @Override
//                    public void onPicAdd() {
//                        if (addPic != null) {
//                            addPic.onAddPic();
//                        }
//                    }
//                });
//                RecyclerView recycler = holder.getView(R.id.recycler);
//                recycler.setLayoutManager(new GridLayoutManager(mContext, 3));
//                recycler.setAdapter(pictureAdapter);
//                break;
//        }
    }

    @Override
    public int getItemViewType(int position) {
        return PICTURE;
    }

    public void initTimePicker() {
        Calendar currentDate = Calendar.getInstance();
        Calendar endDate = Calendar.getInstance();
        endDate.set(3000, 12, 31);
        //初始化时间选择器
        pvTime = new TimePickerBuilder(mContext, (date, v) -> {//选中事件回调
            long timeBegin = 0;
            long timeEnd = 0;
        }).setLayoutRes(R.layout.pickerview_custom_time, v -> {
            Button btnSubmit = v.findViewById(R.id.btnSubmit);
            Button btnCancel = v.findViewById(R.id.btnCancel);
            //确定
            btnSubmit.setOnClickListener(v1 -> {
                pvTime.returnData();
                pvTime.dismiss();
            });
            //取消
            btnCancel.setOnClickListener(v2 -> {
                pvTime.dismiss();
            });
        }).setType(new boolean[]{true, true, true, false, false, false})
                .setLabel("年", "月", "日", "", "", "") //设置空字符串以隐藏单位提示   hide label
                .setDividerColor(Color.DKGRAY)
                .setContentTextSize(20)
                .setDate(currentDate)
                .setRangDate(currentDate, endDate)
//                .setDecorView((ViewGroup) findViewById(R.id.root))//非dialog模式下,设置ViewGroup,
                // pickerView将会添加到这个ViewGroup中
                .setBackgroundId(0xb0000000)
                .setOutSideCancelable(false)
                .build();
        pvTime.setKeyBackCancelable(false);//系统返回键监听屏蔽掉
    }

    public interface AddPic {
        void onAddPic();
    }

    public void setOnAddPic(AddPic addPic) {
        this.addPic = addPic;
    }

}
